From 5946adea8ce799f0871fa4e1ff427a7c33b619bd Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Fri, 9 Jul 2021 04:27:26 +0000
Subject: [PATCH] [arm64] port luma_vps

luma_vps[  4x4]		6.36x 	 65.05    	 413.82
luma_vps[  8x8]		15.87x 	 101.26   	 1606.85
luma_vps[16x16]		16.42x 	 390.10   	 6404.52
luma_vps[32x32]		16.71x 	 1516.97  	 25355.14
luma_vps[64x64]		16.99x 	 5998.71  	 101932.57
luma_vps[  8x4]		15.35x 	 52.62    	 807.69
luma_vps[  4x8]		6.20x 	 132.04   	 819.03
luma_vps[ 16x8]		16.29x 	 195.75   	 3188.13
luma_vps[ 8x16]		16.22x 	 198.53   	 3220.36
luma_vps[32x16]		16.76x 	 757.35   	 12694.37
luma_vps[16x32]		14.50x 	 874.74   	 12681.12
luma_vps[64x32]		16.86x 	 3008.40  	 50726.70
luma_vps[32x64]		16.77x 	 3021.61  	 50677.77
luma_vps[16x12]		16.46x 	 290.68   	 4785.45
luma_vps[12x16]		12.74x 	 376.66   	 4799.63
luma_vps[ 16x4]		15.90x 	 100.51   	 1597.74
luma_vps[ 4x16]		6.19x 	 265.11   	 1640.22
luma_vps[32x24]		16.71x 	 1142.39  	 19084.79
luma_vps[24x32]		16.66x 	 1141.67  	 19022.84
luma_vps[ 32x8]		16.55x 	 383.95   	 6352.91
luma_vps[ 8x32]		16.44x 	 389.32   	 6401.08
luma_vps[64x48]		16.92x 	 4494.55  	 76035.30
luma_vps[48x64]		16.76x 	 4551.87  	 76274.48
luma_vps[64x16]		16.86x 	 1503.97  	 25364.21
luma_vps[16x64]		16.66x 	 1528.49  	 25464.07
---
 source/common/aarch64/asm-primitives.cpp |  26 +++
 source/common/aarch64/ipfilter8.S        | 278 ++++++++++++++++++++++-
 source/common/aarch64/ipfilter8.h        |  26 +++
 source/common/arm/ipfilter8.S            |   1 -
 4 files changed, 329 insertions(+), 2 deletions(-)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index a7f5bca..4ff01af 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -252,6 +252,32 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.pu[LUMA_24x32].luma_vsp   = PFX(interp_8tap_vert_sp_24x32_neon);
         p.pu[LUMA_48x64].luma_vsp   = PFX(interp_8tap_vert_sp_48x64_neon);
         p.pu[LUMA_12x16].luma_vsp   = PFX(interp_8tap_vert_sp_12x16_neon);
+
+        p.pu[LUMA_4x4].luma_vps     = PFX(interp_8tap_vert_ps_4x4_neon);
+        p.pu[LUMA_4x8].luma_vps     = PFX(interp_8tap_vert_ps_4x8_neon);
+        p.pu[LUMA_4x16].luma_vps    = PFX(interp_8tap_vert_ps_4x16_neon);
+        p.pu[LUMA_8x4].luma_vps     = PFX(interp_8tap_vert_ps_8x4_neon);
+        p.pu[LUMA_8x8].luma_vps     = PFX(interp_8tap_vert_ps_8x8_neon);
+        p.pu[LUMA_8x16].luma_vps    = PFX(interp_8tap_vert_ps_8x16_neon);
+        p.pu[LUMA_8x32].luma_vps    = PFX(interp_8tap_vert_ps_8x32_neon);
+        p.pu[LUMA_16x4].luma_vps    = PFX(interp_8tap_vert_ps_16x4_neon);
+        p.pu[LUMA_16x8].luma_vps    = PFX(interp_8tap_vert_ps_16x8_neon);
+        p.pu[LUMA_16x16].luma_vps   = PFX(interp_8tap_vert_ps_16x16_neon);
+        p.pu[LUMA_16x32].luma_vps   = PFX(interp_8tap_vert_ps_16x32_neon);
+        p.pu[LUMA_16x64].luma_vps   = PFX(interp_8tap_vert_ps_16x64_neon);
+        p.pu[LUMA_16x12].luma_vps   = PFX(interp_8tap_vert_ps_16x12_neon);
+        p.pu[LUMA_32x8].luma_vps    = PFX(interp_8tap_vert_ps_32x8_neon);
+        p.pu[LUMA_32x16].luma_vps   = PFX(interp_8tap_vert_ps_32x16_neon);
+        p.pu[LUMA_32x32].luma_vps   = PFX(interp_8tap_vert_ps_32x32_neon);
+        p.pu[LUMA_32x64].luma_vps   = PFX(interp_8tap_vert_ps_32x64_neon);
+        p.pu[LUMA_32x24].luma_vps   = PFX(interp_8tap_vert_ps_32x24_neon);
+        p.pu[LUMA_64x16].luma_vps   = PFX(interp_8tap_vert_ps_64x16_neon);
+        p.pu[LUMA_64x32].luma_vps   = PFX(interp_8tap_vert_ps_64x32_neon);
+        p.pu[LUMA_64x64].luma_vps   = PFX(interp_8tap_vert_ps_64x64_neon);
+        p.pu[LUMA_64x48].luma_vps   = PFX(interp_8tap_vert_ps_64x48_neon);
+        p.pu[LUMA_24x32].luma_vps   = PFX(interp_8tap_vert_ps_24x32_neon);
+        p.pu[LUMA_48x64].luma_vps   = PFX(interp_8tap_vert_ps_48x64_neon);
+        p.pu[LUMA_12x16].luma_vps   = PFX(interp_8tap_vert_ps_12x16_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index ee9a73c..35af2a8 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -476,7 +476,6 @@ LUMA_VPP_4xN 16
 .loop_\filterv\()_\a\()x\b:
 
     mov             x7, x2
-    mov             x6, x0
     mov             x9, #0
 
 .loop_w8_\filterv\()_\a\()x\b:
@@ -1052,6 +1051,283 @@ function x265_interp_8tap_vert_sp_12x16_neon
     cbnz            x5, .loop1_12x16
     ret
 endfunc
+//**************luma_vps*****************
+.macro LUMA_VPS_4xN h
+// void interp_vert_ps_c(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx)
+function x265_interp_8tap_vert_ps_4x\h\()_neon
+    lsl             x3, x3, #1
+    lsl             x5, x4, #6
+    lsl             x4, x1, #2
+    sub             x4, x4, x1
+    sub             x0, x0, x4
+
+    mov             w6, #8192
+    dup             v28.4s, w6
+    mov             x4, #\h
+
+.loop_vps_4x\h:
+    movrel          x12, g_lumaFilter
+    add             x12, x12, x5
+    mov             x6, x0
+
+    ld1             {v0.s}[0], [x6], x1
+    uxtl            v0.8h, v0.8b
+    uxtl            v0.4s, v0.4h
+    ld1r            {v16.2d}, [x12], #8
+
+    ld1             {v1.s}[0], [x6], x1
+    uxtl            v1.8h, v1.8b
+    uxtl            v1.4s, v1.4h
+    ld1r            {v17.2d}, [x12], #8
+    mul             v0.4s, v0.4s, v16.4s
+
+    ld1             {v2.s}[0], [x6], x1
+    uxtl            v2.8h, v2.8b
+    uxtl            v2.4s, v2.4h
+    ld1r            {v18.2d}, [x12], #8
+    mla             v0.4s, v1.4s, v17.4s
+
+    ld1             {v3.s}[0], [x6], x1
+    uxtl            v3.8h, v3.8b
+    uxtl            v3.4s, v3.4h
+    ld1r            {v19.2d}, [x12], #8
+    mla             v0.4s, v2.4s, v18.4s
+
+    ld1             {v4.s}[0], [x6], x1
+    uxtl            v4.8h, v4.8b
+    uxtl            v4.4s, v4.4h
+    ld1r            {v20.2d}, [x12], #8
+    mla             v0.4s, v3.4s, v19.4s
+
+    ld1             {v5.s}[0], [x6], x1
+    uxtl            v5.8h, v5.8b
+    uxtl            v5.4s, v5.4h
+    ld1r            {v21.2d}, [x12], #8
+    mla             v0.4s, v4.4s, v20.4s
+
+    ld1             {v6.s}[0], [x6], x1
+    uxtl            v6.8h, v6.8b
+    uxtl            v6.4s, v6.4h
+    ld1r            {v22.2d}, [x12], #8
+    mla             v0.4s, v5.4s, v21.4s
+
+    ld1             {v7.s}[0], [x6], x1
+    uxtl            v7.8h, v7.8b
+    uxtl            v7.4s, v7.4h
+    ld1r            {v23.2d}, [x12], #8
+    mla             v0.4s, v6.4s, v22.4s
+
+    mla             v0.4s, v7.4s, v23.4s
+
+    sub             v0.4s, v0.4s, v28.4s
+    sqxtn           v0.4h, v0.4s
+    st1             {v0.4h}, [x2], x3
+
+    add             x0, x0, x1
+    sub             x4, x4, #1
+    cbnz            x4, .loop_vps_4x\h
+    ret
+endfunc
+.endm
+
+LUMA_VPS_4xN 4
+LUMA_VPS_4xN 8
+LUMA_VPS_4xN 16
+
+.macro FILTER_VPS a b filterv
+    mov             w12,#8192
+    dup             v30.4s, w12
+.loop_ps_\filterv\()_\a\()x\b:
+
+    mov             x7, x2
+    mov             x9, #0
+
+.loop_ps_w8_\filterv\()_\a\()x\b:
+
+    add             x6, x0, x9
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+
+   \filterv
+
+    sub             v17.4s, v17.4s, v30.4s
+    sqxtn           v0.4h, v17.4s
+    sub             v18.4s, v18.4s, v30.4s
+    sqxtn           v1.4h, v18.4s
+    trn1            v0.2d, v0.2d, v1.2d
+    st1             {v0.16b}, [x7], #16
+
+    add             x9, x9, #8
+    cmp             x9, #\a
+    blt             .loop_ps_w8_\filterv\()_\a\()x\b
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    sub             x5, x5, #1
+    cbnz            x5, .loop_ps_\filterv\()_\a\()x\b
+.endm
+
+.macro LUMA_VPS  w h
+function x265_interp_8tap_vert_ps_\w\()x\h\()_neon
+    lsl             x3, x3, #1
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5
+    mov             x5, #\h
+
+    cmp             x4, #0
+    beq             0f
+    cmp             x4, #1
+    beq             1f
+    cmp             x4, #2
+    beq             2f
+    cmp             x4, #3
+    beq             3f
+0:
+    FILTER_VPS  \w \h qpel_filter_0_32b
+    ret
+1:
+    FILTER_VPS  \w \h qpel_filter_1_32b
+    ret
+2:
+    FILTER_VPS  \w \h qpel_filter_2_32b
+    ret
+3:
+    FILTER_VPS  \w \h qpel_filter_3_32b
+    ret
+endfunc
+.endm
+
+LUMA_VPS 8 4
+LUMA_VPS 8 8
+LUMA_VPS 8 16
+LUMA_VPS 8 32
+LUMA_VPS 16 4
+LUMA_VPS 16 8
+LUMA_VPS 16 16
+LUMA_VPS 16 32
+LUMA_VPS 16 64
+LUMA_VPS 16 12
+LUMA_VPS 32 8
+LUMA_VPS 32 16
+LUMA_VPS 32 32
+LUMA_VPS 32 64
+LUMA_VPS 32 24
+LUMA_VPS 64 16
+LUMA_VPS 64 32
+LUMA_VPS 64 64
+LUMA_VPS 64 48
+LUMA_VPS 24 32
+LUMA_VPS 48 64
+
+function x265_interp_8tap_vert_ps_12x16_neon
+    lsl             x3, x3, #1
+    lsl             x5, x1, #2
+    sub             x5, x5, x1
+    sub             x0, x0, x5
+    mov             x5, #16
+    mov             w12,#8192
+    dup             v30.4s, w12
+.loop_vps_12x16:
+
+    mov             x7, x2
+    mov             x6, x0
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+
+    cmp             x4, #0
+    beq             0f
+    cmp             x4, #1
+    beq             1f
+    cmp             x4, #2
+    beq             2f
+    cmp             x4, #3
+    beq             3f
+0:
+    qpel_filter_0_32b
+    b            5f
+1:
+    qpel_filter_1_32b
+    b            5f
+2:
+    qpel_filter_2_32b
+    b            5f
+3:
+    qpel_filter_3_32b
+    b            5f
+5:
+    sub             v17.4s, v17.4s, v30.4s
+    sqxtn           v0.4h, v17.4s
+    sub             v18.4s, v18.4s, v30.4s
+    sqxtn           v1.4h, v18.4s
+    trn1            v0.2d, v0.2d, v1.2d
+    st1             {v0.16b}, [x7], #16
+
+    add             x6, x0, #8
+
+    ld1             {v0.8b}, [x6], x1
+    ld1             {v4.8b}, [x6], x1
+    ld1             {v1.8b}, [x6], x1
+    ld1             {v5.8b}, [x6], x1
+    ld1             {v2.8b}, [x6], x1
+    ld1             {v6.8b}, [x6], x1
+    ld1             {v3.8b}, [x6], x1
+    ld1             {v7.8b}, [x6], x1
+
+    movi            v17.16b, #0
+    movi            v18.16b, #0
+
+    cmp             x4, #0
+    beq             0f
+    cmp             x4, #1
+    beq             1f
+    cmp             x4, #2
+    beq             2f
+    cmp             x4, #3
+    beq             3f
+0:
+    qpel_filter_0_32b
+    b            5f
+1:
+    qpel_filter_1_32b
+    b            5f
+2:
+    qpel_filter_2_32b
+    b            5f
+3:
+    qpel_filter_3_32b
+    b            5f
+5:
+    sub             v17.4s, v17.4s, v30.4s
+    sqxtn           v0.4h, v17.4s
+    st1             {v0.8b}, [x7], #8
+
+    add             x0, x0, x1
+    add             x2, x2, x3
+    subs            x5, x5, #1
+    cbnz            x5, .loop_vps_12x16
+    ret
+endfunc
 
 .macro vextin8
     ld1             {v3.16b}, [x11], #16
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index 04e6e4d..71ba821 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -102,6 +102,32 @@ void x265_interp_8tap_vert_sp_24x32_neon(const int16_t* src, intptr_t srcStride,
 void x265_interp_8tap_vert_sp_48x64_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 void x265_interp_8tap_vert_sp_12x16_neon(const int16_t* src, intptr_t srcStride, pixel* dst, intptr_t dstStride, int coeffIdx);
 
+void x265_interp_8tap_vert_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_8x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_8x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_8x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_8x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_16x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_16x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_16x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_16x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_16x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_16x12_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_32x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_32x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_32x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_32x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_32x24_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_64x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_64x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_64x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_64x48_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_24x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_48x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+void x265_interp_8tap_vert_ps_12x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx);
+
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
diff --git a/source/common/arm/ipfilter8.S b/source/common/arm/ipfilter8.S
index 3a45942..c995c4d 100644
--- a/source/common/arm/ipfilter8.S
+++ b/source/common/arm/ipfilter8.S
@@ -1719,7 +1719,6 @@ LUMA_VPS_4xN 16
 .loop_ps_\filterv\()_\a\()x\b:
 
     mov             r7, r2
-    mov             r6, r0
     eor             r8, r8
 
 .loop_ps_w8_\filterv\()_\a\()x\b:
-- 
2.25.1

